TH = {};
_G[ "TH" ] = TH;

TH.ChatPattern = "|cffFFFFFF[|cff00dd00TH|cffFFFFFF]: |cffFCFC7D%s|r";
TH.YESPattern = "|cff009900%s|r";
TH.NOPattern = "|cff990000%s|r";
TH.events = { "VARIABLES_LOADED", "SYSTEM_MESSAGE", "CHAT_MSG_GUILD", "CHAT_MSG_PARTY", "CHAT_MSG_SAY", "UNIT_BUFF_CHANGED", "LOADING_END" };
TH.BrokenStep = 0;
TH.SBrokenStep = 0;

TH.SerenstumNeeded = false;

THVariables = {};
TH.DefaultConfig = {
	["InGuild"] = false,
	["InParty"] = true,
	["InSay"] = false,
	["Duration"] = 120,
	["Repeats"] = 1,
	["Serenstum"] = false,
};

SLASH_THALLSUSHELPER1 = "/th";
SlashCmdList["THALLSUSHELPER"] = function(_, msg)
	if( msg == "guild" )then
		THVariables.InGuild = not THVariables.InGuild;
		if( THVariables.InGuild )then
			TH.Message( "Messages in guild: " .. TH.YESPattern:format( "Yes" ) );
		else
			TH.Message( "Messages in guild: " .. TH.NOPattern:format( "No" ) );
		end;
		return nil;
	end;
	if( msg == "party" )then
		THVariables.InParty = not THVariables.InParty;
		if( THVariables.InParty )then
			TH.Message( "Messages in party: " .. TH.YESPattern:format( "Yes" ) );
		else
			TH.Message( "Messages in party: " .. TH.NOPattern:format( "No" ) );
		end;
		return nil;
	end;
	if( msg == "say" )then
		THVariables.InSay = not THVariables.InSay;
		if( THVariables.InSay )then
			TH.Message( "Messages in say: " .. TH.YESPattern:format( "Yes" ) );
		else
			TH.Message( "Messages in say: " .. TH.NOPattern:format( "No" ) );
		end;
		return nil;
	end;
	if( tonumber( msg ) ~= nil )then
		THVariables.Duration = tonumber( msg );
		if( THVariables.Duration < 0 )then THVariables.Duration = THVariables.Duration * -1; end;
		TH.Message( "Focus message time count " .. THVariables.Duration );
		return nil;
	end;
	if( msg == "repeats" )then
		THRepeatsConfig:Show();
	end;
	if( msg == "serenstum" )then
		THVariables.Serenstum = not THVariables.Serenstum;
		if( THVariables.Serenstum )then
			TH.Message( "Autouse serenstum: " .. TH.YESPattern:format( "Yes" ) );
		else
			TH.Message( "Autouse serenstum: " .. TH.NOPattern:format( "No" ) );
		end;
		return nil;
	end;
	TH.Message( "Unknown command /th " .. msg );
	TH.Message( "Use /th <guild/party/say/[number]/repeats/serenstum> for configure" );
end;

function TH.Message( text )
	text = tostring( text );
	ChatFrame1:AddMessage( TH.ChatPattern:format( text ) );
	if( MUIChatFrame ~= nil )then
		MUIChatFrameChat1:AddMessage( TH.ChatPattern:format( text ) );
	end;
end;

function TH.ChatMessage( text )
	if( THVariables.InGuild )then SendChatMessage( text, "GUILD" ); end;
	if( THVariables.InParty )then SendChatMessage( text, "PARTY" ); end;
	if( THVariables.InSay )then SendChatMessage( text, "SAY" ); end;
end;

function TH.OnLoad( this )
	for n = 1, #TH.events do
		this:RegisterEvent( TH.events[ n ] );
	end;
end;

function TH.OnEvent( this, event )
	if( event == "VARIABLES_LOADED" )then
		for key, value in pairs( TH.DefaultConfig )do
			if( THVariables[ key ] == nil )then THVariables[ key ] = value; end;
		end;
		SaveVariables( "THVariables" );
		TH.Message( "Thallsus Helper loading successfully complete" );
		if( THVariables.InGuild )then
			TH.Message( "Messages in guild: " .. TH.YESPattern:format( "Yes" ) );
		else
			TH.Message( "Messages in guild: " .. TH.NOPattern:format( "No" ) );
		end;
		if( THVariables.InParty )then
			TH.Message( "Messages in party: " .. TH.YESPattern:format( "Yes" ) );
		else
			TH.Message( "Messages in party: " .. TH.NOPattern:format( "No" ) );
		end;
		if( THVariables.InSay )then
			TH.Message( "Messages in say: " .. TH.YESPattern:format( "Yes" ) );
		else
			TH.Message( "Messages in say: " .. TH.NOPattern:format( "No" ) );
		end;
		TH.Message( "Focus message time count " .. THVariables.Duration );
		TH.Message( "Focus message repeats " .. THVariables.Repeats );
		if( THVariables.Serenstum )then
			TH.Message( "Autouse serenstum: " .. TH.YESPattern:format( "Yes" ) );
		else
			TH.Message( "Autouse serenstum: " .. TH.NOPattern:format( "No" ) );
		end;
		TH.Message( "Use /th <guild/party/say/[number]/repeats/serenstum> for configure" );
	end;
	if( event == "LOADING_END" )then
		_G[ "THRepeatsConfig" .. "RepeatsDesc" ]:SetText( "Количество повторов:" );
		_G[ "THRepeatsConfig" .. "Repeats" ]:SetValueStepMode("INT");
		_G[ "THRepeatsConfig" .. "Repeats" ]:SetMinMaxValues( 1, 10 );
		_G[ "THRepeatsConfig" .. "RepeatsLow" ]:SetText( "1" );
		_G[ "THRepeatsConfig" .. "RepeatsHigh" ]:SetText( "10" );
		_G[ "THRepeatsConfig" .. "Repeats" ]:SetValue( THVariables.Repeats );
	end;
	if( event == "SYSTEM_MESSAGE" )then
		if( arg1:match( "замораживающим лучом" ) )or( arg1:match( "лучом пламени" ) )then
			local name = UnitName( "player" );
			local player = "|Hplayer:" .. name .. "|h[" .. name .. "]|h";
			for n = 1, THVariables.Repeats do
				TH.ChatMessage( "[TH] " .. player .. " является целью" );
			end;
			TH.SerenstumNeeded = THVariables.Serenstum;
			-- [TH] |Hplayer:|h[Hiori]|h является целью
		end;
	end;
	if( event == "CHAT_MSG_GUILD" )or( event == "CHAT_MSG_PARTY" )or( event == "CHAT_MSG_SAY" )then
		local player = arg1:match( "%[TH%] (.+) является целью" );
		if( player )then
			ThallsusHelperMessageTitle:SetText( player .. " ЯВЛЯЕТСЯ ЦЕЛЬЮ!" );
			ThallsusHelperMessage:Show();
		end;
	end;
	if( event == "UNIT_BUFF_CHANGED" )and( arg1 == "player" )then
		local n, flag = 1, false;
		local _, _, _, guid = UnitBuff( "player", n );
		repeat
			_, _, _, guid = UnitBuff( "player", n );
			if( guid == 501190 )then
				ThallsusHelperSerenstum:Show();
				flag = true;
			end;
			n = n + 1;
		until not guid;
		if( not flag )then
			ThallsusHelperSerenstum:Hide();
		end;
	end;
end;

function TH.FocusOnUpdate( this, elapsedTime )
	if( not ThallsusHelperMessage:IsVisible() )then return nil; end;
	
	local count = THVariables.Duration;
	ThallsusHelperMessageTitle:SetAlpha( 1 - ( TH.BrokenStep / count ) );

	TH.BrokenStep = TH.BrokenStep + 1;
	if( TH.BrokenStep > count )then
		ThallsusHelperMessage:Hide();
		TH.BrokenStep = 0;
	end;
end;

function TH.SerenstumOnUpdate( this, elapsedTime )
	if( not ThallsusHelperSerenstum:IsVisible() )then return nil; end;
	
	local count = 40;
	local n, flag = 1, false;
	local _, _, _, guid = UnitBuff( "player", n );
	repeat
		_, _, _, guid = UnitBuff( "player", n );
		if( guid == 501190 )then
			local _time = UnitBuffLeftTime( "player", n );
			ThallsusHelperSerenstumTitle:SetText( "Серенстум использован, оставшееся время: " .. string.format( "%.1f", _time ) .. "c" );
			flag = true;
		end;
		n = n + 1;
	until not guid;
	if( not flag )then
		ThallsusHelperSerenstum:Hide();
		return nil;
	end;
	ThallsusHelperSerenstumTitle:SetAlpha( 1 - ( TH.SBrokenStep / count ) );

	TH.SBrokenStep = TH.SBrokenStep + 1;
	if( TH.SBrokenStep > count )then
		ThallsusHelperMessage:Hide();
		TH.SBrokenStep = 0;
	end;
end;

function TH.RCOnLoad( this )
	UIPanelBackdropFrame_SetTexture( this, "Interface/Common/PanelCommonFrame", 256, 256 );
end;

function TH.RepeatsOnValueChanged( this )
	if( not THRepeatsConfig:IsVisible() )then return nil; end;
	THVariables.Repeats = this:GetValue();
end;



------------------------------------
--  HOOKS
------------------------------------

local oldJump=Jump;
function Jump()
	if( TH.SerenstumNeeded )then UseItemByName( "Серенстум" ); TH.SerenstumNeeded = false; end;
	return oldJump();
end

local oldMoveForwardStart=MoveForwardStart;
function MoveForwardStart()
	if( TH.SerenstumNeeded )then UseItemByName( "Серенстум" ); TH.SerenstumNeeded = false; end;
	return oldMoveForwardStart();
end

local oldMoveForwardStop=MoveForwardStop;
function MoveForwardStop()
	if( TH.SerenstumNeeded )then UseItemByName( "Серенстум" ); TH.SerenstumNeeded = false; end;
	oldMoveForwardStop();
end

local oldMoveBackwardStart=MoveBackwardStart;
function MoveBackwardStart()
	if( TH.SerenstumNeeded )then UseItemByName( "Серенстум" ); TH.SerenstumNeeded = false; end;
	return oldMoveBackwardStart();
end

local oldMoveBackwardStop=MoveBackwardStop;
function MoveBackwardStop()
	if( TH.SerenstumNeeded )then UseItemByName( "Серенстум" ); TH.SerenstumNeeded = false; end;
	return oldMoveBackwardStop();
end

local oldStrafeLeftStart=StrafeLeftStart;
function StrafeLeftStart()
	if( TH.SerenstumNeeded )then UseItemByName( "Серенстум" ); TH.SerenstumNeeded = false; end;
	return oldStrafeLeftStart();
end

local oldStrafeLeftStop=StrafeLeftStop;
function StrafeLeftStop()
	if( TH.SerenstumNeeded )then UseItemByName( "Серенстум" ); TH.SerenstumNeeded = false; end;
	return oldStrafeLeftStop();
end

local oldStrafeRightStart=StrafeRightStart;
function StrafeRightStart()
	if( TH.SerenstumNeeded )then UseItemByName( "Серенстум" ); TH.SerenstumNeeded = false; end;
	return oldStrafeRightStart();
end

local oldStrafeRightStop=StrafeRightStop;
function StrafeRightStop()
	if( TH.SerenstumNeeded )then UseItemByName( "Серенстум" ); TH.SerenstumNeeded = false; end;
	return oldStrafeRightStop();
end

local THLogout = Logout;
function Logout()
	Jump = oldJump;
	MoveForwardStart = oldMoveForwardStart;
	MoveForwardStop = oldMoveForwardStop;
	MoveBackwardStart = oldMoveBackwardStart;
	MoveBackwardStop = oldMoveBackwardStop;
	StrafeLeftStart = oldStrafeLeftStart;
	StrafeLeftStop = oldStrafeLeftStop;
	StrafeRightStart = oldStrafeRightStart;
	StrafeRightStop = oldStrafeRightStop;
	return THLogout();
end
